import { IEffectsAction } from 'redux-effects-promise';
import { IStringTokenWrapper } from '../../definitions.interface';
export declare class ApplicationActionBuilder {
    static buildCustomErrorAction(error: string): IEffectsAction;
    static buildPrepareAction(): IEffectsAction;
    static buildPrepareDoneAction(): IEffectsAction;
    static buildReadyAction(): IEffectsAction;
    static buildNotReadyAction(): IEffectsAction;
    static buildAfterLoginAction(): IEffectsAction;
    static buildAuthorizedAction(payload?: IStringTokenWrapper): IEffectsAction;
    static buildUnauthorizedAction(): IEffectsAction;
    static buildAfterLogoutAction(): IEffectsAction;
    static buildAfterInitAction(): IEffectsAction;
    static buildReadyActionType(): string;
    static buildNotReadyActionType(): string;
    /**
     * @stable [23.10.2018]
     * @returns {string}
     */
    static buildPathActionType(): string;
    static buildAuthorizedActionType(): string;
    static buildUnauthorizedActionType(): string;
    static buildPrepareActionType(): string;
    static buildPrepareDoneActionType(): string;
    static buildPrepareErrorActionType(): string;
    /**
     * If there a chain of async tasks
     * @stable [31.07.2018]
     * @returns {string}
     */
    static buildPrepareDoneErrorActionType(): string;
    static buildInitActionType(): string;
    static buildAfterInitActionType(): string;
    static buildCustomErrorActionType(): string;
    static buildLogoutActionType(): string;
    static buildMountActionType(): string;
    static buildAfterLogoutActionType(): string;
    static buildAfterLoginActionType(): string;
}
