"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var chart_js_1 = require("chart.js");
var base_1 = require("../base");
var layout_1 = require("../layout");
var util_1 = require("../../util");
var Chart = /** @class */ (function (_super) {
    __extends(Chart, _super);
    function Chart() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.canvasId = util_1.uuid(true);
        return _this;
    }
    /**
     * @stable [24.09.2018]
     */
    Chart.prototype.componentDidMount = function () {
        _super.prototype.componentDidMount.call(this);
        var elId = document.getElementById(this.canvasId);
        if (elId) {
            var ctx = elId.getContext('2d');
            new chart_js_1.Chart(ctx, this.props.options);
        }
    };
    /**
     * @stable [14.06.2018]
     * @returns {JSX.Element}
     */
    Chart.prototype.render = function () {
        var _this = this;
        var props = this.props;
        return (React.createElement(layout_1.FlexLayout, { row: true, className: util_1.toClassName(props.className, 'rac-chart') },
            props.west,
            util_1.orNull(props.rendered !== false, function () { return (React.createElement(layout_1.FlexLayout, { className: 'rac-chart-canvas-holder' },
                React.createElement(layout_1.FlexLayout, { className: 'rac-chart-canvas-wrapper' },
                    React.createElement("canvas", { id: _this.canvasId })))); }),
            props.east));
    };
    return Chart;
}(base_1.BaseComponent));
exports.Chart = Chart;
//# sourceMappingURL=chart.component.js.map