import * as React from 'react';
import { Dialog } from '../dialog.component';
import { IArbitraryFormDialogProps, IArbitraryFormDialogState } from './arbitrary-form-dialog.interface';
export declare class ArbitraryFormDialog extends Dialog<ArbitraryFormDialog, IArbitraryFormDialogProps, IArbitraryFormDialogState> {
    private static REDUCER_FORM_SECTION;
    /**
     * @stable [03.08.2018]
     * @param {IArbitraryFormDialogProps} props
     */
    constructor(props: IArbitraryFormDialogProps);
    /**
     * @stable [03.08.2018]
     */
    activate(callback: () => void): void;
    /**
     * @stable [03.08.2018]
     */
    onAccept(): void;
    /**
     * @stable [03.08.2018]
     * @returns {React.ReactNode}
     */
    protected getDialogBodyElement(): React.ReactNode;
    /**
     * @stable [03.08.2018]
     * @returns {boolean}
     */
    protected isAcceptButtonDisabled(): boolean;
    /**
     * @stable [03.08.2018]
     * @param {boolean} valid
     */
    private onFormValid;
    /**
     * @stable [03.08.2018]
     * @param {IFieldChangeEntity} payload
     */
    private onFormChange;
    /**
     * @stable [03.08.2018]
     * @param {AnyT} payload
     * @returns {IEditableEntity}
     */
    private buildNextFormState;
}
