"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var select_1 = require("../../field/select");
var multifield_plugin_1 = require("./multifield.plugin");
var util_1 = require("../../../util");
var MultiField = /** @class */ (function (_super) {
    __extends(MultiField, _super);
    function MultiField() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.multiFieldPlugin = new multifield_plugin_1.MultiFieldPlugin(_this);
        return _this;
    }
    /**
     * @stable [01.06.2018]
     * @param {IKeyboardEvent} event
     */
    MultiField.prototype.onKeyBackspace = function (event) {
        // Do nothing, only need to invoke the props callback
        var props = this.props;
        if (props.onKeyBackspace) {
            props.onKeyBackspace(event);
        }
    };
    /**
     * @stable [19.11.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.addItem = function (item) {
        this.multiFieldPlugin.onAddItem(item);
    };
    /**
     * @stable [19.08.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.deleteItem = function (item) {
        this.onDelete(item);
    };
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.editItem = function (item) {
        this.onEdit(item);
    };
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.mergeItem = function (item) {
        this.onMerge(item);
    };
    /**
     * @stable [01.06.2018]
     * @returns {EntityIdT[]}
     */
    MultiField.prototype.getEmptyValue = function () {
        return [];
    };
    /**
     * @stable [11.08.2018]
     * @param {ISelectOptionEntity} option
     */
    MultiField.prototype.onSelect = function (option) {
        this.multiFieldPlugin.onAddItem({ id: option.value, rawData: option.rawData });
    };
    /**
     * @stable [01.06.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.onDelete = function (item) {
        this.multiFieldPlugin.onDeleteItem(item);
    };
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.onEdit = function (item) {
        this.multiFieldPlugin.onEditItem(item);
    };
    /**
     * @stable [29.08.2018]
     * @param {IMultiItemEntity} item
     */
    MultiField.prototype.onMerge = function (item) {
        this.multiFieldPlugin.onMergeItem(item);
    };
    /**
     * @stable [19.06.2018]
     * @param {ISelectOptionEntity[]} options
     * @returns {ISelectOptionEntity[]}
     */
    MultiField.prototype.toFilteredOptions = function () {
        var activeValue = this.multiFieldPlugin.activeValue;
        var result = _super.prototype.toFilteredOptions.call(this);
        return this.props.notUseActiveValueFilter
            ? result
            : result.filter(function (option) { return !activeValue.find(function (item) { return item.id === option.value; }); });
    };
    /**
     * @stable [21.09.2018]
     * @returns {string}
     */
    MultiField.prototype.getFieldClassName = function () {
        return util_1.toClassName(_super.prototype.getFieldClassName.call(this), 'rac-multifield');
    };
    /**
     * @stable [01.06.2018]
     */
    MultiField.defaultProps = {
        displayMessage: '%d value(s)',
        clearActionRendered: false,
        errorMessageRendered: false,
        forceReload: true,
        preventFocus: true,
        displayValue: function (value, field) {
            var len = field.multiFieldPlugin.getActiveValueLength(value);
            return field.printfDisplayMessage(len > 0, len);
        },
    };
    return MultiField;
}(select_1.BasicSelect));
exports.MultiField = MultiField;
//# sourceMappingURL=multifield.component.js.map