"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var redux_effects_promise_1 = require("redux-effects-promise");
var definitions_interface_1 = require("../../definitions.interface");
/**
 * @stable [05.04.2018]
 */
exports.INITIAL_APPLICATION_LIST_STATE = {
    changes: {},
    directions: {},
    progress: false,
    touched: false,
    lockPage: false,
    data: null,
    rawData: null,
    selected: null,
    page: definitions_interface_1.FIRST_PAGE,
    pageSize: definitions_interface_1.DEFAULT_PAGE_SIZE,
    totalCount: 0,
};
/**
 * @stable [05.08.2018]
 */
exports.INITIAL_APPLICATION_LIST_MAX_PAGE_STATE = {
    page: definitions_interface_1.FIRST_PAGE,
    pageSize: definitions_interface_1.DEFAULT_MAX_PAGE_SIZE,
};
exports.LIST_LOAD_ACTION_TYPE = 'list.load';
exports.LIST_CANCEL_LOAD_ACTION_TYPE = 'list.cancel.load';
exports.LIST_LAZY_LOAD_ACTION_TYPE = 'list.lazy.load';
exports.LIST_LOAD_DONE_ACTION_TYPE = redux_effects_promise_1.EffectsActionBuilder.buildDoneActionType(exports.LIST_LOAD_ACTION_TYPE);
exports.LIST_LOAD_ERROR_ACTION_TYPE = redux_effects_promise_1.EffectsActionBuilder.buildErrorActionType(exports.LIST_LOAD_ACTION_TYPE);
exports.LIST_LAZY_LOAD_DONE_ACTION_TYPE = redux_effects_promise_1.EffectsActionBuilder.buildDoneActionType(exports.LIST_LAZY_LOAD_ACTION_TYPE);
exports.LIST_LAZY_LOAD_ERROR_ACTION_TYPE = redux_effects_promise_1.EffectsActionBuilder.buildErrorActionType(exports.LIST_LAZY_LOAD_ACTION_TYPE);
exports.LIST_UN_TOUCH_ACTION_TYPE = 'list.untouch';
exports.LIST_DESTROY_ACTION_TYPE = 'list.destroy';
exports.LIST_SELECT_ACTION_TYPE = 'list.select';
exports.LIST_CREATE_ACTION_TYPE = 'list.create';
exports.LIST_EMPTY_MESSAGE_CLICK_ACTION_TYPE = 'list.empty.message.click';
exports.LIST_DESELECT_ACTION_TYPE = 'list.deselect';
exports.LIST_UPDATE_ACTION_TYPE = 'list.update';
exports.LIST_INSERT_ACTION_TYPE = 'list.insert';
exports.LIST_REMOVE_ACTION_TYPE = 'list.remove';
exports.LIST_CHANGE_ACTION_TYPE = 'list.change';
exports.LIST_CHANGE_SORT_DIRECTION_ACTION_TYPE = 'list.change.sort.direction';
exports.LIST_NEXT_PAGE_ACTION_TYPE = 'list.next.page';
exports.LIST_PREVIOUS_PAGE_ACTION_TYPE = 'list.previous.page';
exports.LIST_FIRST_PAGE_ACTION_TYPE = 'list.first.page';
exports.LIST_LAST_PAGE_ACTION_TYPE = 'list.last.page';
//# sourceMappingURL=list.interface.js.map