"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
Object.defineProperty(exports, "__esModule", { value: true });
var menu_1 = require("@material/menu");
var vue_property_decorator_1 = require("vue-property-decorator");
var util_1 = require("../../util");
var vue_index_1 = require("../connector/vue-index");
var vue_index_2 = require("../base/vue-index");
var VueMenu = /** @class */ (function (_super) {
    __extends(VueMenu, _super);
    /**
     * @stable [17.11.2018]
     */
    function VueMenu() {
        var _this = _super.call(this) || this;
        _this.onMenuClose = _this.onMenuClose.bind(_this);
        return _this;
    }
    /**
     * @stable [17.11.2018]
     * @param {IVueMenuContextEntity} context
     */
    VueMenu.prototype.show = function (context) {
        var _this = this;
        this.$data.opened = true;
        this.$nextTick(function () {
            _this.bindMenu();
            _this.openMenu(context);
        });
    };
    /**
     * @stable [17.11.2018]
     * @param {IVueMenuContextEntity} context
     */
    VueMenu.prototype.openMenu = function (context) {
        this.mdc.open = true;
        if (util_1.isDef(context)) {
            if (util_1.isNumber(context.width)) {
                util_1.setWidth(this.getSelf(), context.width);
            }
        }
    };
    /**
     * @stable [17.11.2018]
     */
    VueMenu.prototype.bindMenu = function () {
        if (this.mdc) {
            return;
        }
        this.mdc = menu_1.MDCMenu.attachTo(this.el = this.getSelf());
        this.mdc.hoistMenuToBody(); // Prevent an outer container scroll appearing
        this.mdc.listen('MDCMenuSurface:closed', this.onMenuClose);
    };
    /**
     * @stable [17.11.2018]
     */
    VueMenu.prototype.onMenuClose = function () {
        this.mdc.unlisten('MDCMenuSurface:closed', this.onMenuClose);
        this.mdc.destroy();
        this.mdc = null;
        this.$data.opened = false;
        util_1.removeSelf(this.el);
    };
    /**
     * @stable [17.11.2018]
     * @param {IMenuItemEntity} option
     */
    VueMenu.prototype.onSelect = function (option) {
        this.$emit('select', option);
    };
    /**
     * @stable [17.11.2018]
     * @returns {string}
     */
    VueMenu.prototype.getPleaseWaitMessage = function () {
        return this.settings.messages.waitMessage;
    };
    /**
     * @stable [22.12.2018]
     * @param {IMenuItemEntity} item
     * @returns {EntityIdT}
     */
    VueMenu.prototype.getDisplayValue = function (item) {
        return item.label
            ? (this.useLocalization ? this.t(item.label) : item.label)
            : item.value;
    };
    /**
     * @stable [22.12.2018]
     * @param {IMenuItemEntity} item
     * @returns {any}
     */
    VueMenu.prototype.getTemplateValue = function (item) {
        return this.tpl(item);
    };
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Array)
    ], VueMenu.prototype, "options", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Boolean)
    ], VueMenu.prototype, "useLocalization", void 0);
    __decorate([
        vue_property_decorator_1.Prop(),
        __metadata("design:type", Function)
    ], VueMenu.prototype, "tpl", void 0);
    VueMenu = __decorate([
        vue_index_1.ComponentName('vue-menu'),
        vue_property_decorator_1.Component({
            data: function () { return ({
                opened: false,
            }); },
            template: "\n      <div v-if=\"opened\"\n           class=\"mdc-menu-surface--anchor\">\n          <div ref=\"self\"\n               class=\"vue-menu mdc-menu mdc-menu-surface\">\n              <ul class=\"vue-menu-list mdc-list\"\n                  role=\"menu\"\n                  aria-hidden=\"true\"\n                  aria-orientation=\"vertical\">\n                  <li v-for=\"item in options\"\n                      class=\"vue-menu-list-item mdc-list-item\"\n                      role=\"menuitem\"\n                      @click=\"onSelect(item)\"\n                  >\n                      <component v-if=\"tpl\"\n                                 :is=\"{template: getTemplateValue(item)}\"/>\n                      <template v-if=\"!tpl\">{{getDisplayValue(item)}}</template>\n                  </li>\n                  <li v-if=\"!options\"\n                      class=\"vue-menu-list-empty-item\">\n                        <span class=\"vue-menu-list-empty-item-text mdc-list-item__text\">\n                            {{getPleaseWaitMessage()}}\n                        </span>\n                  </li>\n              </ul>\n          </div>\n      </div>\n  ",
        }),
        __metadata("design:paramtypes", [])
    ], VueMenu);
    return VueMenu;
}(vue_index_2.VueBaseComponent));
//# sourceMappingURL=vue-menu.component.js.map