import { IEffectsAction } from 'redux-effects-promise';
import { ITabConfiguration, ITabPanelConfiguration } from '../../configurations-definitions.interface';
import { IActiveValueWrapper } from '../../definitions.interface';
import { ITabPanelWrapperEntity } from '../../entities-definitions.interface';
/**
 * @stable [31.08.2018]
 * @param {IEffectsAction} action
 * @param {string} alias
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {boolean}
 */
export declare const isTabActivated: (action: IEffectsAction, alias: string, tabPanelConfiguration: ITabPanelConfiguration) => boolean;
/**
 * @stable [31.08.2018]
 * @param {string} alias
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {ITabConfiguration}
 */
export declare const findTabByAlias: (alias: string, tabPanelConfiguration: ITabPanelConfiguration) => ITabConfiguration;
/**
 * @stable [31.08.2018]
 * @param {string} alias
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {ITabConfiguration}
 */
export declare const findTabValueByAlias: (alias: string, tabPanelConfiguration: ITabPanelConfiguration) => ITabConfiguration;
/**
 * @stable [31.08.2018]
 * @param {IActiveValueWrapper} activeValueWrapper
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @param {string} alias
 * @returns {boolean}
 */
export declare const isTabActiveByAlias: (activeValueWrapper: IActiveValueWrapper<number>, tabPanelConfiguration: ITabPanelConfiguration, alias: string) => boolean;
/**
 * @stable [31.08.2018]
 * @param {ITabPanelWrapperEntity} tabPanelWrapperEntity
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @param {string} alias
 * @returns {boolean}
 */
export declare const isTabPanelWrapperEntityActiveByAlias: (tabPanelWrapperEntity: ITabPanelWrapperEntity, tabPanelConfiguration: ITabPanelConfiguration, alias: string) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IActiveValueWrapper} activeValueWrapper
 * @param {ITabConfiguration} tab
 * @returns {boolean}
 */
export declare const isTabActive: (activeValueWrapper: IActiveValueWrapper<number>, tab: ITabConfiguration) => boolean;
/**
 * @stable [30.08.2018]
 * @param {IActiveValueWrapper} props
 * @param {ITabPanelConfiguration} tabPanelConfiguration
 * @returns {number}
 */
export declare const getTabActiveValue: (props: IActiveValueWrapper<number>, tabPanelConfiguration: ITabPanelConfiguration) => number;
