import { IKeyValue } from '../../definitions.interface';
import { VueBaseComponent } from '../base/vue-index';
import { VueCreateElementFactoryT, VueNodeT } from '../../vue-definitions.interface';
import { IVueViewerState, IVueViewerTemplateMethodsEntity, IVueViewerProps } from './vue-viewer.interface';
export declare class VueViewer<TVueViewerState extends IVueViewerState = IVueViewerState> extends VueBaseComponent<IKeyValue, TVueViewerState> implements IVueViewerProps {
    src: string;
    previewAttachment: string;
    /**
     * @stable [29.11.2018]
     * @param {VueCreateElementFactoryT} createElement
     * @returns {VueNodeT}
     */
    render(createElement: VueCreateElementFactoryT): VueNodeT;
    /**
     * @stable [29.11.2018]
     * @returns {TVueViewerStateEntity}
     */
    getInitialData$(): TVueViewerState;
    /**
     * @stable [29.11.2018]
     * @returns {IVueViewerTemplateMethodsEntity}
     */
    protected getTemplateMethods(): IVueViewerTemplateMethodsEntity;
    /**
     * @stable [09.12.2018]
     */
    protected onRemove(): void;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPopupFooterTemplate(): string;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPopupHeaderTemplate(): string;
    /**
     * @stable [29.11.2018]
     * @returns {string}
     */
    protected getPreviewTemplate(): string;
    /**
     * @stable [22.12.2018]
     * @returns {string}
     */
    protected getPreviewTemplateAttachment(): string;
    /**
     * @stable [22.12.2018]
     * @returns {string}
     */
    protected getPreviewClassName(): string;
    /**
     * @stable [28.11.2018]
     * @returns {string}
     */
    protected getPopupBodyTemplate(): string;
    /**
     * @stable [28.11.2018]
     */
    protected onAfterOpenPopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onAfterClosePopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onOpenPopup(): void;
    /**
     * @stable [28.11.2018]
     */
    protected onClosePopup(): void;
}
