"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
/**
 * @stable [19.08.2018]
 * @param {string} time
 * @returns {string}
 */
exports.normalizeTime = function (time) { return "" + (time.length > 1 ? time : ['0', time].join('')); };
/**
 * @stable [19.08.2018]
 * @param {number} time
 * @returns {string}
 */
exports.fromTimeAtMinutesToTimeAtString = function (time) {
    var minutesAtString = String(Math.floor(time / 60));
    var secondsAtString = String(time % 60);
    return exports.normalizeTime(minutesAtString) + ":" + exports.normalizeTime(secondsAtString);
};
/**
 * @stable [19.08.2018]
 * @param {string} time1
 * @param {string} time2
 * @returns {number}
 */
exports.getDiffAtSecondsBetween = function (time1, time2) {
    var d1 = new Date("01/01/2018 " + time1);
    var d2 = new Date("01/01/2018 " + time2);
    return (d2.getTime() - d1.getTime()) / 1000;
};
/**
 * @stable [19.08.2018]
 * @param {string} time1
 * @param {string} time2
 * @returns {number}
 */
exports.getDiffAtMinutesBetween = function (time1, time2) {
    return exports.getDiffAtSecondsBetween(time1, time2) / 60;
};
/**
 * @stable [19.08.2018]
 * @param {string} time1
 * @returns {number}
 */
exports.getDiffAtMinutes = function (time1) { return exports.getDiffAtMinutesBetween('00:00', time1); };
//# sourceMappingURL=time.js.map